/* UW8 - Operator Services src/add_info.c
 * Copyright (c) 1998 Chris Birch <uw8@othernet.org>
 * Original code and design by Michael Dabrowski <devon@othernet.org> UW7.5
 * All further GNU development and publication rights of this software are
 * granted to Chris Birch by Michael Dabrowski.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */           


#include<bot.h>

void add_resvinfo(char *nick, char *user, char *host, char *reason)
{
   struct resvinfo *new, *current;
   new = (struct resvinfo *) calloc(1, sizeof(struct resvinfo));
   if(new != NULL)
   {
      new->next = NULL;
      
      strcpy(new->nick, nick);
      strcpy(new->user, user);
      strcpy(new->host, host);
      strcpy(new->reason, reason);
      if(resvhead == NULL) resvhead = new;
      else
      {
         current = resvhead;
         while(current->next != NULL) current = current->next;
         current->next = new;
      }
   }
   else log(ERRLOG_FILE, "[%s] Adding Reserve List: Out of memory\n", date());
}

void add_jupeinfo(char *nick, char *server, int numeric, char *reason)
{
   struct jupeinfo *new, *current;
   new = (struct jupeinfo *) calloc(1, sizeof(struct jupeinfo));
   if(new != NULL)
   {
      new->next = NULL;
      strcpy(new->nick, nick);
      strcpy(new->server, server);
      strcpy(new->reason, reason);
      new->numeric = numeric;
      if(jupehead == NULL) jupehead = new;
      else
      {
         current = jupehead;
         while(current->next != NULL) current = current->next;
         current->next = new;
      }
   }
   else log(ERRLOG_FILE, "[%s] Adding Jupe List: Out of memory\n", date());
}

void add_mapinfo(char *line)
{
   struct mapinfo *new, *current;
   new = (struct mapinfo *) calloc(1, sizeof(struct mapinfo));
   if(new != NULL)
   {
      new->next = NULL;
      strcpy(new->mapline, line);
      if(maphead == NULL) maphead = new;
      else
      {
         current = maphead;
         while(current->next != NULL) current = current->next;
         current->next = new;
      }
   }
   else log(ERRLOG_FILE, "[%s] Adding map: Out of memory\n", date());
}

void add_templist(char *chan)
{
   struct templist *new, *current;
   new = (struct templist *) calloc(1, sizeof(struct templist));
   if(new != NULL)
   {
      new->next = NULL;
      strcpy(new->channel, chan);
      if(listhead == NULL) listhead = new;
      else
      {
         current = listhead;
         while(current->next != NULL) current = current->next;
         current->next = new;
      }
   }
   else log(ERRLOG_FILE, "[%s] Adding chanlist: Out of memory\n", date());
}

void add_glineinfo(char *who, char *hostmask, long gtime, char *reason, char *fulltime)
{
   struct ginfo *new, *current;

   new = (struct ginfo *) calloc(1, sizeof(struct ginfo));
   if(new != NULL)
   {
       new->next = NULL;
       strcpy(new->who, who);
       strcpy(new->hostmask, hostmask);
       new->gtime = gtime;
       strcpy(new->reason, reason);
       strcpy(new->fulltime, fulltime);
       if(ghead == NULL)
       {
          ghead = new;
       }
       else
       {
          current = ghead;
          while(current->next != NULL)
          {
             current = current->next;
          }
          current->next = new;
       }
   }
   else
   {
      log(ERRLOG_FILE, "[%s] Adding new gline: Out of memory\n", date());
      return;
   }
}

void add_hostchk(char *nick)
{
   struct hostchk *new, *current;
   new = (struct hostchk *) calloc(1, sizeof(struct hostchk));
   if(new != NULL)
   {
      new->next = NULL;
      strcpy(new->nick, nick);
      if(hosthead == NULL) hosthead = new;
      else
      {
         current = hosthead;
         while(current->next != NULL) current = current->next;
         current->next = new;
      }
   }
   else log(ERRLOG_FILE, "[%s] Adding new hostcheck: Out of memory\n", date());
}

void add_secretinfo(char *chan)
{
   struct secretinfo *new, *current;

   new = (struct secretinfo *) calloc(1, sizeof(struct secretinfo));
   if(new != NULL)
   {
       new->next = NULL;
       strcpy(new->channel, chan);
       if(secrethead == NULL) secrethead = new;
       else
       {
          current = secrethead;
          while(current->next != NULL) current = current->next;
          current->next = new;
       }
   }
   else
   {
      log(ERRLOG_FILE, "[%s] Adding new secret: Out of memory\n", date());
      return;
   }
}

void add_badinfo(char *chan)
{
   struct badinfo *new, *current;

   new = (struct badinfo *) calloc(1, sizeof(struct badinfo));
   if(new != NULL)
   {
       new->next = NULL;
       strcpy(new->channel, chan);
       if(badhead == NULL) badhead = new;
       else
       {
          current = badhead;
          while(current->next != NULL) current = current->next;
          current->next = new;
       }
   }
   else
   {
      log(ERRLOG_FILE, "[%s] Adding new bad: Out of memory\n", date());
      return;
   }
}

void add_trustinfo(char *host)
{
   struct trustinfo *new, *current;

   new = (struct trustinfo *) calloc(1, sizeof(struct trustinfo));
   if(new != NULL)
   {   
       new->next = NULL; 
       strcpy(new->host, host);
       if(trusthead == NULL) trusthead = new;
       else
       {
          current = trusthead;
          while(current->next != NULL) current = current->next;
          current->next = new;
       }
   }
   else
   {
      log(ERRLOG_FILE, "[%s] Adding new Host: Out of memory\n", date());
      return;
   }
}
