/* UW8 - Operator Services src/add_secret.c
 * Copyright (c) 1998 Chris Birch <uw8@othernet.org>
 * Original code and design by Michael Dabrowski <devon@othernet.org> UW7.5
 * All further GNU development and publication rights of this software are
 * granted to Chris Birch by Michael Dabrowski.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#include<bot.h>

void add_secret(char *who, char *rest)
{
   FILE *sfile;
   struct secretinfo *new, *current;
   char *hostmask, *reason, *nwho, *chan, *helpname;
   int i=0;

   nwho=nick2num(who);
   helpname = get_command_name("addsecret");
   if(rest == NULL || rest[0] == '\0')
   {
      do_help(who, helpname);
      return;
   }
   chan = strtok(rest, " ");
   current = secrethead;
   while(current != NULL)
   {
      if(!strcasecmp(chan, current->channel))
      {
         send_to_server(":%s NOTICE %s :That word is already in the secret channel list\n", bot.nick, nwho);
         return;
      }
      current = current->next;
   }
   add_secretinfo(chan);
   send_to_server(":%s NOTICE %s :That word %s is added to the secret list\n", bot.nick, nwho, chan);
   write_secretchan();
}

void del_secret(char *who, char *rest)
{
   FILE *fp, *fp2;
   char buff[300], *filler, *chan, *nwho, *helpname;
   struct secretinfo *current, *previous;

   nwho=nick2num(who);
   helpname = get_command_name("delsecret");
   if(rest == NULL || rest[0] == '\0')
   {
      do_help(who, helpname);
      return;
   }
   chan = strtok(rest, " ");
   current = secrethead;
   while(current != NULL)
   {
      if(!strcasecmp(rest, current->channel)) break;
      else
      {
         previous = current;
         current = current->next;
      }
   }
   if(current == NULL) 
   {
      send_to_server(":%s NOTICE %s :Secret word %s not found in list\n", bot.nick, nwho, chan);
      return;
   }
   else
   {
      if(current == secrethead) secrethead = secrethead->next;
      else previous->next = current->next;
      free(current);
      send_to_server(":%s NOTICE %s :Secret word %s removed\n", bot.nick, nwho, chan);
      write_secretchan();
      return;
   }
}
