/* UW8 - Operator Services src/gline.c
 * Copyright (c) 1998 Chris Birch <uw8@othernet.org>
 * Original code and design by Michael Dabrowski <devon@othernet.org> UW7.5
 * All further GNU development and publication rights of this software are
 * granted to Chris Birch by Michael Dabrowski.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include<bot.h>

void do_gline(char *who, char *rest)
{
   FILE *gfile;
   struct ginfo *new, *current;
   char *hostmask, *dtime, *reason, *host, *waste, *helpname;
   long  gtime, i = 0;
   char *nwho;

   nwho=nick2num(who);
   helpname = get_command_name("gline");
   if(rest == NULL || rest[0] == '\0' || strchr(rest,'!') != NULL)
   {
      do_help(who, helpname);
      return;
   }
   if((dtime = strchr(rest, ' ')) != NULL) *dtime++ = '\0';
   else
   {
      send_to_server(":%s NOTICE %s :You must specify a GLINE duration in seconds, read help\n", bot.nick, nwho);
      return;
   }
   if(!strchr(rest, '@'))
   {
      send_to_server(":%s NOTICE %s :You must specify a user@host(ex. *@*.aol.com)\n", bot.nick, nwho);
      return;
   }
   if(check_gline(rest))
   {
      send_to_server(":%s NOTICE %s :A bit excessive , isn't it, you mad as someone?\n", bot.nick, nwho);
      return;
   }
   if(atol(dtime) < 2)
   {
      send_to_server(":%s NOTICE %s :You must specify a GLINE duration in seconds, read help\n", bot.nick, nwho);
      return;
   }
   if((reason = strchr(dtime, ' ')) != NULL) *reason++ = '\0';
   else
   {
      send_to_server(":%s NOTICE %s :You must specify a REASON, read help\n", bot.nick, nwho);
      return;
   }
   current = ghead;
   while(current != NULL)
   {
      if(!bancmp(current->hostmask, rest) || !bancmp(rest, current->hostmask))
      {
         if(!strcasecmp(current->hostmask, rest))
         {
            send_to_server(":%s NOTICE %s :GLINE for that hostmask: %s  already exists\n", bot.nick, nwho, current->hostmask);
            return;
         }
         if(strlen(rest) < strlen(current->hostmask))
            do_ungline(who, current->hostmask);
         else
         {
            send_to_server(":%s NOTICE %s :GLINE already covered\n", bot.nick, nwho);
            return;
         }
      }
      current = current->next;
   }
   send_to_server(":%s GLINE * +%s %s :%s\n", myserver, rest, dtime, reason);
   gtime = time(NULL) + atol(dtime);
   send_to_server(":%s WALLOPS :GLINE %s expires %s\n", myserver, rest,  ctime(&gtime));
   add_glineinfo(who, rest, gtime, reason, ctime(&gtime));
   write_gline();
}

void do_ungline(char *who, char *rest)
{
   char *nick, *hostmask, *gtime, host[100];
   char *reason, buff[300], *helpname;
   struct ginfo *current, *previous;
   char *nwho;

   nwho=nick2num(who);
   helpname = get_command_name("ungline");
   if(rest == NULL || rest[0] == '\0')
   {
      do_help(who, helpname);
      return;
   }
   if((reason = strchr(rest, ' ')) != NULL) *reason++ = '\0';
   current = ghead;
   while(current != NULL)
   {
      if(!strcasecmp(rest, current->hostmask)) break;
      else
      {
         previous = current;
         current = current->next;
      }
   }
   if(current == NULL) return;
   else
   {
      if(current == ghead) ghead = ghead->next;
      else previous->next = current->next;
      free(current);
      send_to_server(":%s GLINE * -%s\n", myserver, rest);
      send_to_server(":%s NOTICE %s :Removed GLINE for hostmask %s\n", bot.nick, nwho, rest);
   }
   write_gline();
}

int check_gline(char *mask)
{
    char *ptr;

    if(!strcasecmp(mask, "*@*")) return 1;
    if(ptr = strrchr(mask, '.'))
    {
       *--ptr;
       if(ptr[0] == '*')
       {
          return 1;
       }
   }  
   return 0;
}
