/* UW8 - Operator Services src/misc_cmds.c
 * Copyright (c) 1998 Chris Birch <uw8@othernet.org>
 * Original code and design by Michael Dabrowski <devon@othernet.org> UW7.5
 * All further GNU development and publication rights of this software are
 * granted to Chris Birch by Michael Dabrowski.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */           


#include<bot.h>

void kick_ban_all(char *who, char *rest)
{
   struct nickinfo *nick;
   struct chaninfo *current;
   char *nwho = NULL, *chan = NULL, *banmask = NULL, test[1000], *reason = NULL, *uhost = NULL;
   
   test[0]='\0';
   nwho = nick2num(who);
   strcpy(test, rest);
   chan = strtok(test, " ");
   if(*chan == '+' || *chan == '&') return;
   if(chan_check(chan, who) == -1) return;
   if((reason = strchr(rest, ' ')) != NULL) *reason++ = '\0';
   else
   {
      send_to_server(":%s NOTICE %s :You must specify a KICK reason, read help\n", bot.nick, nwho);
      return;
   }
   nick = nickhead;
   while(nick != NULL)
   {
      current = nick->chanhead;
      while(current != NULL)
      {
         if(!strcasecmp(rest, current->channel) && strcasecmp(nick->nick, who) && strcasecmp(nick->nick, chanserv))
         {
            if(uhost = getuserhost(nick->nick));
            if(uhost != NULL)
            {
               banmask = get_ban_mask(uhost);
               send_to_server(":%s MODE %s -o+b %s %s\n", myserver, rest, nick->numeric, banmask);
               send_to_server(":%s KICK %s %s :%s\n", myserver, rest, nick->numeric, reason);
            }
         }
         current = current->next;
      }
      nick = nick->next;
   }
}

void kick_all(char *who, char *rest)
{
   struct nickinfo *nick;
   struct chaninfo *current;
   char *nwho = NULL, *chan = NULL, test[1000], *reason = NULL;
   
   test[0]='\0';
   nwho = nick2num(who);
   strcpy(test, rest);
   chan = strtok(test, " ");
   if(*chan == '+' || *chan == '&') return;
   if(chan_check(chan, who) == -1) return;
   if((reason = strchr(rest, ' ')) != NULL) *reason++ = '\0';
   else
   {
      send_to_server(":%s NOTICE %s :You must specify a KICK reason, read help\n", bot.nick, nwho);
      return;
   }
   nick = nickhead;
   while(nick != NULL)
   {
      current = nick->chanhead;
      while(current != NULL)
      {
         if(!strcasecmp(rest, current->channel) && strcasecmp(nick->nick, who) && strcasecmp(nick->nick, chanserv))
         {
            send_to_server(":%s KICK %s %s :%s\n", myserver, rest, nick->numeric, reason);
         }
         current = current->next;
      }
      nick = nick->next;
   }
}

void kick_user(char *who, char *rest)
{
   char *nwho = NULL, *nick = NULL, *reason = NULL, *ptr = NULL, *chan = NULL, *nnick = NULL, test[1000], *uhost = NULL;
   char *helpname;
   struct nickinfo *tmp1;
   struct chaninfo *tmp2;

   test[0]='\0';
   nwho=nick2num(who);
   strcpy(test, rest);
   chan = strtok(test, " ");
   if(*chan == '+' || *chan == '&') return;
   if(chan_check(chan, who) == -1) return;
   if(nick = strchr(rest, ' ')) *nick++ = '\0';
   else
   {
      helpname = get_command_name("kick");
      do_help(who, "helpname");
      return;
   }
   if(reason = strchr(nick, ' ')) *reason++ = '\0';
   else reason = "Lamer!";
   strlwr(chan);
   if(strlen(reason) > 100) reason[99] = '\0';
   if((uhost = getuserhost(nick)) == NULL)
   {
     send_to_server(":%s NOTICE %s :   User %s is not online\n", bot.nick, nwho, nick);
     return;
   }
   nnick=nick2num(nick);
   if(!strcasecmp(chanserv, nick)) return;
   send_to_server(":%s KICK %s %s :%s\n", myserver, chan, nnick, reason);
}

void clearmode(char *who, char *rest)
{
   char *chan;
   char *nwho;
   
   nwho = nick2num(who);
   chan = strtok(rest, " ");
   if(*chan == '+' || *chan == '&') return;
   if(chan_check(chan, who) == -1) return;
   send_to_server(":%s MODE %s\n", myserver, rest);
}

void show_uptime(char *who, char *rest)
{
   int days = 0, hours = 0, mins = 0, secs = 0;
   char *nwho = NULL;
   nwho=nick2num(who);

   secs = time(NULL) - uptime;
   if(secs > 60) 
   {
      mins = secs / 60;
      secs -= 60 * mins;
   } else mins = 0;
   if(mins > 60) 
   {
      hours = mins / 60;
      mins -= 60 * hours;
   } else hours = 0;
   if(hours > 24) 
   {
      days = hours / 24;
      hours -= 24 * days;
   } else days = 0;
   send_to_server(":%s NOTICE %s :Uptime is %02d Days, %02d Hours, %02d Minutes, %02d Seconds\n", bot.nick, nwho, days, hours, mins, secs);
}

void unmoderate(char *who, char *rest)
{
   struct nickinfo *nick;
   struct chaninfo *current;
   char nickbuff[3000], md[10], test[1000], *chan = NULL;
   int num_nicks=0;
   char *nwho;
   
   nwho = nick2num(who);
   test[0]='\0';md[0]='\0';nickbuff[0]='\0';
   strcpy(test, rest);
   chan = strtok(test, " ");
   if(*chan == '+' || *chan == '&') return;
   if(chan_check(chan, who) == -1) return;
   nickbuff[0]='\0';
   md[0]='\0';
   send_to_server(":%s MODE %s -m\n", myserver, chan);
   nick = nickhead;
   while(nick != NULL)
   {
      current = nick->chanhead;
      while(current != NULL)
      {
         if(!strcasecmp(chan,current->channel) && strcasecmp(nick->nick, chanserv))
         {
            if(num_nicks < 6)
            {
               strcat(nickbuff, nick->numeric);
               strcat(nickbuff, " ");
               strcat(md, "v");
               num_nicks++;
            }
            if(num_nicks == 5)
            {
               send_to_server(":%s MODE %s -%s %s\n", myserver, chan, md, nickbuff);
               num_nicks = 0;
               nickbuff[0]='\0';
               md[0]='\0';
            }
         }
         current=current->next;
      }
      nick=nick->next;
   }
   if(num_nicks > 0)
   {
      send_to_server(":%s MODE %s -%s %s\n", myserver, chan, md, nickbuff);
   }
}

void moderate(char *who, char *rest)
{
   struct nickinfo *nick;
   struct chaninfo *current;
   char nickbuff[3000], md[10], test[1000], *chan = NULL;
   int num_nicks=0;
   char *nwho;
   
   nwho = nick2num(who);
   test[0]='\0';md[0]='\0';nickbuff[0]='\0';
   strcpy(test, rest);
   chan = strtok(test, " ");
   if(*chan == '+' || *chan == '&') return;
   if(chan_check(chan, who) == -1) return;
   nickbuff[0]='\0';
   md[0]='\0';
   send_to_server(":%s MODE %s +m\n", myserver, chan);
   nick = nickhead;
   while(nick != NULL)
   {
      current = nick->chanhead;
      while(current != NULL)
      {
         if(!strcasecmp(chan,current->channel) && strcasecmp(nick->nick, chanserv))
         {
            if(num_nicks < 6)
            {
               strcat(nickbuff, nick->numeric);
               strcat(nickbuff, " ");
               strcat(md, "v");
               num_nicks++;
            }
            if(num_nicks == 5)
            {
               send_to_server(":%s MODE %s +%s %s\n", myserver, chan, md, nickbuff);
               num_nicks = 0;
               nickbuff[0]='\0';
               md[0]='\0';
            }
         }
         current=current->next;
      }
      nick=nick->next;
   }
   if(num_nicks > 0)
   {
      send_to_server(":%s MODE %s +%s %s\n", myserver, chan, md, nickbuff);
   }
}

void deopall(char *who, char *rest)
{
   struct nickinfo *nick;
   struct chaninfo *current;
   char nickbuff[3000], md[100], test[1000], *chan = NULL;
   int num_nicks=0;
   char *nwho;
   
   nwho = nick2num(who);
   test[0]='\0';md[0]='\0';nickbuff[0]='\0';
   strcpy(test, rest);
   chan = strtok(test, " ");
   if(*chan == '+' || *chan == '&') return;
   if(chan_check(chan, who) == -1) return;
   nickbuff[0]='\0';
   md[0]='\0';
   nick = nickhead;
   while(nick != NULL)
   {
      current = nick->chanhead;
      while(current != NULL)
      {
         if(!strcasecmp(chan,current->channel) && strcasecmp(chanserv, nick->nick))
         {
            
            if(num_nicks < 6)
            {
               strcat(nickbuff, nick->numeric);
               strcat(nickbuff, " ");
               strcat(md, "o");
               num_nicks++;
            }
            if(num_nicks == 6)
            {
               send_to_server(":%s MODE %s -%s %s\n", myserver, chan, md, nickbuff);
               num_nicks = 0;
               nickbuff[0]='\0';
               md[0]='\0';
            }
         }
         current=current->next;
      }
      nick=nick->next;
   }
   if(num_nicks > 0 && num_nicks < 6)
   {
      send_to_server(":%s MODE %s -%s %s\n", myserver, rest, md, nickbuff);
   }
}

void opall(char *who, char *rest)
{
   struct nickinfo *nick;
   struct chaninfo *current;
   char nickbuff[3000], md[100], test[1000], *chan = NULL, *nwho = NULL;
   int num_nicks=0;

   test[0]='\0';md[0]='\0';nickbuff[0]='\0';
   nwho = nick2num(who);
   strcpy(test, rest);
   chan = strtok(test, " ");
   if(*chan == '+' || *chan == '&') return;
   if(chan_check(chan, who) == -1) return;
   nick = nickhead;
   while(nick != NULL)
   {
      current = nick->chanhead;
      while(current != NULL)
      {
         if(!strcasecmp(chan,current->channel) && strcasecmp(chanserv, nick->nick))
         {
               if(num_nicks < 6)
               {
                  strcat(nickbuff, nick->numeric);
                  strcat(nickbuff, " ");
                  strcat(md, "o");
                  num_nicks++;
               }
               if(num_nicks == 6)
               {
                  send_to_server(":%s MODE %s +%s %s\n", myserver, chan, md, nickbuff);
                  num_nicks = 0;
                  nickbuff[0]='\0';
                  md[0]='\0';
               }
         }
         current=current->next;
      }
      nick=nick->next;
   }
   if(num_nicks > 0 && num_nicks < 6)
   {
      send_to_server(":%s MODE %s +%s %s\n", myserver, chan, md, nickbuff);
   }
}

void invite(char *who, char *rest)
{
   char *nick = NULL, *chan = NULL, test[100];
   char *nwho;
   
   nwho = nick2num(who);
   test[0]='\0';
   strcpy(test, rest);
   if(rest != NULL)
   {
     chan = strtok(test, " ");
     if(*chan == '+' || *chan == '&') return;
     if(chan_check(chan, who) == -1) return;
     nick = strtok(NULL, " ");
     if(nick != NULL)
       send_to_server(":%s INVITE %s %s\n",bot.nick, nick, chan);
     else
       send_to_server(":%s INVITE %s %s\n",bot.nick, who, chan);
   }
   else
     return;
}

void inviteme(char *who, char *rest)
{
   char *nwho = NULL, *nick = NULL;
   nwho = nick2num(who);
   if(*msg_chan != '#')
   {
     send_to_server(":%s NOTICE %s : Messege Channel is not enabled\n",bot.nick, nwho);
     return;
   }
   if(rest != NULL)
   {
     if(strlen(rest) > maxnicklen && *rest == '#') return;
     nick = strtok(rest, " ");
     send_to_server(":%s INVITE %s %s\n",bot.nick, nick, msg_chan);
   }
   else
     send_to_server(":%s INVITE %s %s\n",bot.nick, who, msg_chan);
}

void mode(char *who, char *rest)
{
  struct operinfo *user;
  char *chan = NULL, *modes = NULL, test[100], *nwho = NULL, *testmodes = NULL, *helpname;
  
  test[0]='\0';
  nwho = nick2num(who);
  if(modes=strchr(rest, ' ')) *modes++ = '\0';
  else
  {
     helpname = get_command_name("mode");
     do_help(who, helpname);
     return;
  }
  if(*rest == '+' || *rest == '&') return;
  if(chan_check(rest, who) == -1) return;
  strcpy(test, modes);
  testmodes = strtok(test, " ");
  if(strchr(testmodes, 'o') || strchr(testmodes, 'b'))
  {
     send_to_server(":%s NOTICE %s : Not allowed to modify ops or bans with this command\n", bot.nick, nwho);   
     return;
  }
  send_to_server(":%s MODE %s %s\n", myserver, rest, modes);
}

void show_map(char *who, char *rest)
{
  struct mapinfo *map;
  char *nwho = NULL;

  nwho = nick2num(who);
  map = maphead;
  while(map != NULL)
  {
    send_to_server(":%s NOTICE %s :%s\n", bot.nick, nwho, map->mapline);
    map = map->next;
  }
}

void suspend(char *who, char *rest)
{
   struct operinfo *oper, *user1, *user2;
   char *idnick = NULL, *what = NULL, *nwho = NULL, *reason = NULL, *helpname;

   nwho = nick2num(who);
   if(rest == NULL)
   {
     send_to_server(":%s NOTICE %s : type /msg %s help suspendoper\n", bot.nick, nwho, bot.nick, bot.nick);
     return;
   }
   if(reason = strchr(rest, ' ')) *reason++ = '\0';
   else
   {
     helpname = get_command_name("suspendoper");
     do_help(who, helpname);
     return;
   }
   user1 = ret_oper_level(rest);
   user2 = return_operinfo(who);
      if(user1 == NULL)
      {
          send_to_server(":%s NOTICE %s : That user is not in the oper list\n", bot.nick, nwho);
          return;
      }
      if(user2->level <= user1->level)
      {
         send_to_server(":%s NOTICE %s :You cannot toggle SUSPEND for a user greater than or equal in level\n", bot.nick, nwho);
         return;
      }
         oper = operhead;
         while(oper != NULL)
         {
            if(!strcasecmp(rest, oper->nick))
            {
                if(oper->suspend)
                {
                   oper->suspend = 0;
                   what = "OFF";
                }
                else
                {
                   oper->suspend = 1;
                   what = "ON";
                }
                send_to_server(":%s NOTICE %s :Suspend has been set to %s for %s \n", bot.nick, nwho, what, rest);
                write_oper();
                return;
             }
             oper = oper->next;
          }
}

void hostkill(char *who, char *rest)
{
   struct nickinfo *nick;
   struct templist *temp;
   char *reason, *nwho, *helpname;

   nwho = nick2num(who);
   helpname = get_command_name("hostkill");
   if(rest == NULL || rest[0] == '\0')
   {
      do_help(who, helpname);
      return;
   }
   if((reason = strchr(rest, ' ')) != NULL) *reason++ = '\0';
   else
   {
      reason = "Network Trouble Maker";
   }
   nick = nickhead;
   while(nick != NULL)
   {
      if(!strcasecmp(rest,nick->host))
      {
           if(nick->numeric != NULL)
           {
              add_templist(nick->numeric);
           }
      }
      nick=nick->next;
   }
   temp = listhead;
   while(temp != NULL)
   {
      send_to_server(":%s KILL %s :%s %s\n", bot.nick, temp->channel, bot.nick, reason);
      delete_node(temp->channel);
      temp = temp->next;
   }
   free_templist();
}

void refresh_glines()
{
   struct ginfo *gline;
   long dtime;

   send_to_server(":%s WALLOPS :Refreshing G-Lines\n", myserver);
   gline = ghead;
   while(gline != NULL)
   {
      dtime = gline->gtime - time(NULL);
      send_to_server(":%s GLINE * +%s %ld :%s\n", myserver, gline->hostmask, dtime, gline->reason);
      gline = gline->next;
   }
}

void chankill(char *who, char *rest)
{
   struct nickinfo *nick;
   struct chaninfo *chan;
   struct templist *temp;
   char *reason, numeric[10];
   char *nwho, *helpname;
   int yep = 0;

   nwho=nick2num(who);
   helpname = get_command_name("chankill");
   if(rest == NULL || rest[0] == '\0')
   {
      do_help(who, helpname);
      return;
   }
   if((reason = strchr(rest, ' ')) != NULL) *reason++ = '\0';
   else
   {
      send_to_server(":%s NOTICE %s :You must specify a KILL reason, read help\n", bot.nick, nwho);
      return;
   }
   if(*rest == '+' || *rest == '&') return;
   nick = nickhead;
   while(nick != NULL)
   {
      if(strcasecmp(who, nick->nick) && strcasecmp(chanserv, nick->nick))
      {
         chan = nick->chanhead;
         while(chan != NULL)
         {
            if(!strcasecmp(rest, chan->channel))
            {
                add_templist(nick->numeric);
            }
            chan = chan->next;
         }
      }
      nick = nick->next;
   }
   temp = listhead;
   while(temp != NULL)
   {
      send_to_server(":%s KILL %s :%s %s\n", bot.nick, temp->channel, bot.nick, reason);
      delete_node(temp->channel);
      temp = temp->next;
   }
   free_templist();
}

void settime()
{
 send_to_server(":%s SETTIME %lu :%s\n", myserver, time(NULL), myserver);
}
