/* UW8 - Operator Services src/write_files.c
 * Copyright (c) 1998 Chris Birch <uw8@othernet.org>
 * Original code and design by Michael Dabrowski <devon@othernet.org> UW7.5
 * All further GNU development and publication rights of this software are
 * granted to Chris Birch by Michael Dabrowski.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 1, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */           


#include<bot.h>

void write_gline()
{
   FILE *fp;
   int i = 0;
   struct ginfo *gline;

   if((fp = fopen(G_FILE, "w")) == NULL)
   {
      file_error(G_FILE);
      return;
   }
   gline = ghead;
   if(gline == NULL) return;
   while(gline != NULL)
   {
     fprintf(fp, "%s %s %d %s\n",gline->who, gline->hostmask, gline->gtime, gline->reason);
     gline = gline->next;
   }
   fclose(fp);
}

void write_jupe()
{
   FILE *fp;
   int i = 0;
   struct jupeinfo *jupe;

   if((fp = fopen(JP_FILE, "w")) == NULL)
   {
      file_error(JP_FILE);
      return;
   }
   jupe = jupehead;
   if(jupe == NULL) return;
   while(jupe != NULL)
   {
     fprintf(fp, "%s %s %d %s\n",jupe->nick, jupe->server, jupe->numeric, jupe->reason);
     jupe = jupe->next;
   }
   fclose(fp);
}

void write_reserve()
{
   FILE *fp;
   int i = 0;
   struct resvinfo *resv;

   if((fp = fopen(RESV_FILE, "w")) == NULL)
   {
      file_error(RESV_FILE);
      return;
   }
   resv = resvhead;
   if(resv == NULL) return;
   while(resv != NULL)
   {
     fprintf(fp, "%s %s %s %s\n", resv->nick, resv->user, resv->host, resv->reason);
     resv = resv->next;
   }
   fclose(fp);
}

void write_comm_list()
{
   FILE *fp;
   int i = 0;
   if((fp = fopen(COM_FILE, "w")) == NULL)
   {
      file_error(COM_FILE);
      return;
   }
   fprintf(fp, "%s\n", "***************************************");
   fprintf(fp, "%s\n", "*   DO NOT Modify this File By Hand   *");
   fprintf(fp, "%s\n", "***************************************");
   for(i = 0; *commands[i].name; i++)
   {
      if(!strcmp(commands[i].realname, " "))
      {
         fclose(fp);
         return;
      }
      fprintf(fp, "%-15s %-15s %-5d %d\n", commands[i].name, commands[i].realname, commands[i].level, commands[i].disable);
   }
   fclose(fp);
}

void write_oper()
{
   FILE *fp;
   struct operinfo *oper;
   struct adderinfo *addr;
   char tmp[1000], tmp1[10000], tmp2[10000];
   int first_time = 0;
         if((fp = fopen(OPER_FILE, "w")) == NULL)
         {
            file_error(OPER_FILE);
            return;
         }
         oper = operhead;
   if(oper == NULL) return;
         while(oper != NULL)
         {
            tmp1[0] = '\0';
            tmp2[0] = '\0';
            sprintf(tmp, "%s %d %d %lu", oper->nick, oper->level, oper->suspend, oper->lastseen);
            addr = oper->adderhead;
            first_time == 0;
            while(addr != NULL)
            {
               if(!first_time)
               {
                  strcpy(tmp1, addr->address);
                  first_time=1;
               }
               else
               {
                  sprintf(tmp2, "%s %s", tmp1, addr->address);
                  strcpy(tmp1, tmp2);
               }
               addr = addr->next;
            }
            fprintf(fp, "%s %s\n", tmp, tmp1);
            oper = oper->next;
         }
         fclose(fp);
         return;
}

void write_secretchan()
{
   FILE *fp;
   struct secretinfo *secret;

   if((fp = fopen(S_FILE, "w")) == NULL)
   {
      file_error(S_FILE);
      return;
   }
   secret = secrethead;
   if(secret == NULL) return;
   while(secret != NULL)
   {
     fprintf(fp, "%s\n", secret->channel);
     secret = secret->next;
   }
   fclose(fp);
}

void write_badchan()
{
   FILE *fp;
   struct badinfo *bad;

   if((fp = fopen(B_FILE, "w")) == NULL)
   {
      file_error(B_FILE);
      return;
   }
   bad = badhead;
   if(bad == NULL) return;
   while(bad != NULL)
   {
     fprintf(fp, "%s\n", bad->channel);
     bad = bad->next;
   }
   fclose(fp);
}

void write_trustinfo()
{
   FILE *fp;
   struct trustinfo *trust;

   if((fp = fopen(H_FILE, "w")) == NULL)
   {
      file_error(H_FILE);
      return;
   }
   trust = trusthead;
   if(trust == NULL) return;
   while(trust != NULL)
   {
     fprintf(fp, "%s\n", trust->host);
     trust = trust->next;
   }
   fclose(fp);
}

void write_maxuser()
{
   FILE *fp;

   if((fp = fopen(MAX_FILE, "w")) == NULL)
   {
      file_error(MAX_FILE);
      return;
   }
   fprintf(fp, "%d %s\n", maxnumber, get_time(time(NULL)));
   strcpy(maxdate, get_time(time(NULL)));
   fclose(fp);
}

void write_all_files()
{
   if(!joined)
   {
      printf(" ********************************\n");
      printf(" Seems to be a problem with joins\n");
      printf(" ********************************\n");
      exit(0);
   }
   if(joined)
   {
      write_comm_list();
      write_oper();
      write_jupe();
      write_reserve();
      write_badchan();
      write_trustinfo();
      write_secretchan();
      send_to_server(":%s WALLOPS :Wrote Out ALL Bot Files\n", myserver);
   }
}
